import { JSXNode, JSXElement } from '../jsx';
import { Path } from '../diff';
import { JSXAsync } from './jsx';
/**
 * Diffs an asynchronous JSX node with itself overtime. Because asynchronous
 * JSX nodes are internally converted into `Observable`s it is possible that
 * the node will update itself over time. Therefore we need to diff these
 * versions to incrementally update our render tree.
 */
export declare function diffAsync(jsx: JSXAsync, initialJSX?: JSXNode, path?: Path): Observable<({
    type: "NODE_REPLACE";
    path: string[];
    node: boolean | number | string | JSXElement | null | undefined;
} | {
    type: "ATTRIBUTE_SET";
    path: string[];
    name: string;
    value: any;
} | {
    type: "ATTRIBUTE_REMOVE";
    path: string[];
    name: string;
} | {
    type: "CHILDREN_ADD";
    path: string[];
    key: string;
    node: boolean | number | string | JSXElement | null | undefined;
} | {
    type: "CHILDREN_REMOVE";
    path: string[];
    key: string;
} | {
    type: "CHILDREN_ORDER";
    path: string[];
    keys: string[];
})[]>;
