import { JSXNode } from '../jsx';
import { JSXAsync } from './jsx';
/**
 * Takes an asynchronous JSX element and flattens it into an observable of
 * synchronous JSX nodes. Great and easy function for making most synchronous
 * interfaces asynchronous.
 *
 * Also note that many elements will be strictly equal across many observable
 * emissions, so it’s fairly easy to reduce computations using the synchronous
 * observable using strict equality checks (`===`).
 */
export declare function flattenAsyncJSX(jsx: JSXAsync): Observable<JSXNode>;
